#include <stdio.h>
#include <stdlib.h>

typedef struct _cvor
{
	char c;
	int broj_pojavljivanja;
	struct _cvor *levo;
	struct _cvor *desno;
}cvor;

void greska(char *s)
{
	fprintf(stderr, "greska: %s\n", s);
	exit(EXIT_FAILURE);
}

cvor* kreiraj_cvor(char c)
{
	cvor *novi = malloc(sizeof(cvor));
	if(novi == NULL)
		greska("malloc");
		
	novi->c = c;
	novi->broj_pojavljivanja = 1;
	novi->levo = NULL;
	novi->desno = NULL;
	return novi;
}

cvor* dodaj_u_stablo(cvor *koren, char c)
{
	if(koren == NULL)
		return kreiraj_cvor(c);
	
	if(koren->c == c)
	{
		koren->broj_pojavljivanja++;
		return koren;
	}
	
	if(c < koren->c)
		koren->levo = dodaj_u_stablo(koren->levo, c);
	else
		koren->desno = dodaj_u_stablo(koren->desno, c);
	return koren;
}

cvor* ucitaj_stablo()
{
	cvor *stablo = NULL;
	FILE *f = fopen("karakteri.txt", "r");
	if(f == NULL)
		greska("fopen");
		
	char c;
	while((c = fgetc(f)) != EOF)
		stablo = dodaj_u_stablo(stablo, c);
	
	fclose(f);
	
	return stablo;
}

cvor* maksimum(cvor *stablo)
{
	if(stablo == NULL)
		return NULL;
	
	cvor *max_l = maksimum(stablo->levo);
	cvor *max_d = maksimum(stablo->desno);
	
	cvor *max_dete = NULL;
	if(max_l == NULL)
		max_dete = max_d;
	else if(max_d == NULL)
		max_dete = max_l;
	else
		max_dete = 
			max_l->broj_pojavljivanja > 
				max_d->broj_pojavljivanja ?
			max_l : max_d;
	
	if(max_dete == NULL)
		return stablo;
	
	return 
		max_dete->broj_pojavljivanja >
			stablo->broj_pojavljivanja ?
		max_dete : stablo;
}

int main()
{
	cvor *stablo = ucitaj_stablo();
	cvor *max = maksimum(stablo);
	
	if(max == NULL)
		printf("ulazna datoteka je prazna\n");
	else
		printf("karakter koji se pojavljuje najvise puta je %c\n", max->c);
	
	
	//ZA DOMACI
	//stablo = oslobodi(stablo);
	
	return 0;
}