#include <stdio.h>
#include <stdlib.h>

#define VREDNOST 0
#define OPERATOR 1

typedef struct _cvor
{
	int tip;
	int vrednost;
	char operator;
	struct _cvor *levo;
	struct _cvor *desno;
}cvor;

cvor* kreiraj_operator(char c)
{
	cvor *novi = malloc(sizeof(cvor));
	//PROVERA DOMACI
	novi->tip = OPERATOR;
	novi->levo = NULL;
	novi->desno = NULL;
	novi->operator = c;
	return novi;
}

cvor* kreiraj_vrednost(int broj)
{
	cvor *novi = malloc(sizeof(cvor));
	//PROVERA DOMACI
	novi->tip = VREDNOST;
	novi->levo = NULL;
	novi->desno = NULL;
	novi->vrednost = broj;
	return novi;
}

cvor* ucitaj(char *s, int *i)
{
	//preskacemo praznine
	while(s[*i] == ' ')
		(*i)++;
	
	if(s[*i] == '+' ||
		s[*i] == '*' ||
		s[*i] == '-' ||
		s[*i] == '/')
	{
		cvor *novi = kreiraj_operator(s[*i]);
		//+ 2 3
		(*i)++;
		novi->levo = ucitaj(s, i);
		novi->desno = ucitaj(s, i);
		return novi;
	}
	else
	{
		int broj = 0;
		while('0' <= s[*i] && s[*i] <= '9')
		{
			broj = broj * 10 + (s[*i] - '0');
			(*i)++;
		}
		//123 +...
		cvor *novi = kreiraj_vrednost(broj);
		return novi;	
	}
}

int izracunaj(cvor *izraz)
{
	if(izraz->tip == VREDNOST)
	{
		return izraz->vrednost;
	}
	else
	{
		int v1 = izracunaj(izraz->levo);
		int v2 = izracunaj(izraz->desno);
		
		switch (izraz->operator)
		{
			case '+':
				return v1 + v2;
			case '-':
				return v1 - v2;
			case '*':
				return v1 * v2;
			case '/':
				return v1 / v2;
		}
		return 0;
	}
}

void ispis(cvor *izraz)
{
	if(izraz->tip == VREDNOST)
	{
		printf("%d", izraz->vrednost);
	}
	else
	{
		//+ 2 3
		//(2 + 3)
		printf("(");
		ispis(izraz->levo);
		printf("%c", izraz->operator);
		ispis(izraz->desno);
		printf(")");
	}
}

int main()
{
	char *s = "+ 12 * - 14 + * 7 2 8 3";
	int i = 0;
	cvor *izraz = ucitaj(s, &i);
	printf("%d\n", izracunaj(izraz));
	ispis(izraz);
	
	//DOMACI OSLOBODI STABLO
}