#include <stdio.h>
#include <stdlib.h>

typedef struct _cvor {
	char c;
	int broj_pojavljivanja;
	struct _cvor *levo;
	struct _cvor *desno;
}cvor;

cvor *kreiraj_novi(char c) {
	cvor *novi = malloc(sizeof(cvor));
	//PROVERA DOMACI
	novi->c = c;
	novi->broj_pojavljivanja = 1;
	novi->levo = NULL;
	novi->desno = NULL;
	return novi;
}

cvor* dodaj_u_stablo(cvor* koren, char c)
{
	if(koren == NULL)
		return kreiraj_novi(c);
	
	if(koren->c == c)
		(koren->broj_pojavljivanja)++;
	else if (c < koren->c)
		koren->levo = dodaj_u_stablo(koren->levo, c);
	else
		koren->desno = dodaj_u_stablo(koren->desno, c);
	return koren;
}

cvor *ucitaj() {
	FILE *f = fopen("karakteri.txt", "r");
	//DOMACI PROVERA
	char c;
	cvor *stablo = NULL;
	while((c = fgetc(f)) != EOF) {
		stablo = dodaj_u_stablo(stablo, c);
	}
	
	fclose(f);
	return stablo;
}

cvor* najveci(cvor *stablo) {
	if(stablo == NULL)
		return NULL;
	
	cvor *max_l = najveci(stablo->levo);
	cvor *max_d = najveci(stablo->desno);
	
	cvor *rez = stablo;
	if(max_l != NULL && 
		max_l->broj_pojavljivanja > rez->broj_pojavljivanja)
		rez = max_l;
	if(max_d != NULL && 
		max_d->broj_pojavljivanja > rez->broj_pojavljivanja)
		rez = max_d;

	return rez;
}

int main(){
	cvor *stablo = ucitaj();
	cvor *max = najveci(stablo);
	if(max == NULL)
		printf("stablo je prazno\n");
	else
		printf("najvise se pojavljuje karakter %c, %d puta\n",
			max->c, max->broj_pojavljivanja);
	
	//DOMACI OSLOBODI STABLO
}