#include <stdio.h>
#include <stdlib.h>

#define OPERATOR 0
#define VREDNOST 1

typedef struct _cvor
{
	int tip;
	char operator;
	int vrednost;
	struct _cvor *levo;
	struct _cvor *desno;
}cvor;

cvor* kreiraj_operator(char c)
{
	cvor *n = malloc(sizeof(cvor));
	//PROVERA DOMACI;
	n->tip = OPERATOR;
	n->operator = c;
	n->levo = NULL;
	n->desno = NULL;
	return n;
}

cvor* kreiraj_vrednost(int vrednost)
{
	cvor *c = malloc(sizeof(cvor));
	//PROVERA DOMACI;
	c->tip = VREDNOST;
	c->vrednost = vrednost;
	c->levo = NULL;
	c->desno = NULL;
	return c;
}

cvor* ucitaj_aritmeticko_stablo(char *s, int *i)
//i nije niz celih brojeva nego adresa na jedan broj
//i predstavlja broj dokle smo stigli sa citanjem 
//u niski s
{
	//posto izraz moze da sadrzi praznine, odnosno ' '
	//moramo prvo da ih preskocimo
	while(s[*i] == ' ')
		(*i)++;
	
	//sada smo naleteli na karakter koji je ili operator
	//ili cifra (podrazumevamo da je izraz ispravno zadat)
	if(s[*i] == '+' ||
		s[*i] == '-' ||
		s[*i] == '*' ||
		s[*i] == '/')
	{
		cvor *rez = kreiraj_operator(s[*i]);
		(*i)++;
		rez->levo = ucitaj_aritmeticko_stablo(s, i);
		rez->desno = ucitaj_aritmeticko_stablo(s, i);
		return rez;
	}
	else
	{
		int vrednost = 0;
		while('0' <= s[*i] && s[*i] <= '9')
		{
			vrednost = vrednost * 10 + s[*i] - '0';
			(*i)++;
		}
		return kreiraj_vrednost(vrednost);
	}
}

int izracunaj(cvor *s)
{
	if(s->tip == VREDNOST)
		return s->vrednost;
	else
	{
		int vl = izracunaj(s->levo);
		int vd = izracunaj(s->desno);
		switch (s->operator)
		{
			case '+': return vl + vd;
			case '-': return vl - vd;
			case '*': return vl * vd;
			case '/': return vl / vd;
		}
	}
}

void ispis(cvor *s)
{
	if(s->tip == VREDNOST)
		printf("%d", s->vrednost);
	else
	{
		printf("(");
		ispis(s->levo);
		printf("%c", s->operator);
		ispis(s->desno);
		printf(")");
	}
}

int main()
{
	char *s = "* 2 + 12 * 8 - 7 4";
	int i = 0;
	cvor *as = ucitaj_aritmeticko_stablo(s, &i);
	printf("%d\n", izracunaj(as));
	ispis(as);
	//DOMACI OSLOBODI STABLO
}